---
title: Create Rule Mapping
description: The POST {{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings operation creates a new propagation attribute mapping rule associated with the specified propagation rule.
component: pingone-api
page_id: pingone-api:platform:identity-propagation-provisioning/propagation-mappings/create-rule-mapping
canonical_url: https://developer.pingidentity.com/pingone-api/platform/identity-propagation-provisioning/propagation-mappings/create-rule-mapping.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Rule Mapping

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings
```

The `POST {{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings` operation creates a new propagation attribute mapping rule associated with the specified propagation rule.

### Prerequisites

* Refer to [Identity Propagation (Provisioning)](../../identity-propagation-provisioning.html) for important overview information.

* [Create a propagation rule](../propagation-rules/create-rule.html) to get a `ruleID` for the endpoint. Refer also to [Identity Propagation (Provisioning)](../../identity-propagation-provisioning.html), especially [Propagation Rules](../propagation-rules.html).

> **Collapse: Request Model**
>
> Refer to [Propagation mapping data model](../propagation-mappings.html#propagation-mapping-data-model) for full property descriptions.
>
> | Property               | Type    | Required?         |
> | ---------------------- | ------- | ----------------- |
> | `attributeMappingType` | Boolean | Optional          |
> | `expression`           | String  | Required/Optional |
> | `name`                 | String  | Required          |
> | `sourceAttribute`      | String  | Required/Optional |
> | `targetAttribute`      | String  | Required          |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "sourceAttribute": "accountId",
    "targetAttribute": "userName",
    "attributeMappingType": "userAttributeMapping"
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "sourceAttribute": "accountId",
    "targetAttribute": "userName",
    "attributeMappingType": "userAttributeMapping"
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""sourceAttribute"": ""accountId""," + "\n" +
@"    ""targetAttribute"": ""userName""," + "\n" +
@"    ""attributeMappingType"": ""userAttributeMapping""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings"
  method := "POST"

  payload := strings.NewReader(`{
    "sourceAttribute": "accountId",
    "targetAttribute": "userName",
    "attributeMappingType": "userAttributeMapping"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "sourceAttribute": "accountId",
    "targetAttribute": "userName",
    "attributeMappingType": "userAttributeMapping"
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"sourceAttribute\": \"accountId\",\n    \"targetAttribute\": \"userName\",\n    \"attributeMappingType\": \"userAttributeMapping\"\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "sourceAttribute": "accountId",
    "targetAttribute": "userName",
    "attributeMappingType": "userAttributeMapping"
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "sourceAttribute": "accountId",
    "targetAttribute": "userName",
    "attributeMappingType": "userAttributeMapping"
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings"

payload = json.dumps({
  "sourceAttribute": "accountId",
  "targetAttribute": "userName",
  "attributeMappingType": "userAttributeMapping"
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "sourceAttribute": "accountId",\n    "targetAttribute": "userName",\n    "attributeMappingType": "userAttributeMapping"\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "sourceAttribute": "accountId",
  "targetAttribute": "userName",
  "attributeMappingType": "userAttributeMapping"
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"sourceAttribute\": \"accountId\",\n    \"targetAttribute\": \"userName\",\n    \"attributeMappingType\": \"userAttributeMapping\"\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/propagation/rules/{{ruleID}}/mappings")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "id": "f65e4fd3-0a56-4bf9-a7ac-44d805344e46",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2022-01-13T21:42:09.972Z",
    "updatedAt": "2022-01-13T21:42:09.972Z",
    "rule": {
        "id": "f9d4c0fc-269d-4645-9079-2795b18f06a6"
    },
    "sourceAttribute": "accountId",
    "targetAttribute": "userName",
    "_links": {
        "get": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/mappings/f65e4fd3-0a56-4bf9-a7ac-44d805344e46"
        },
        "create": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/rules/f9d4c0fc-269d-4645-9079-2795b18f06a6/mappings"
        },
        "update": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/mappings/f65e4fd3-0a56-4bf9-a7ac-44d805344e46"
        },
        "delete": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/mappings/f65e4fd3-0a56-4bf9-a7ac-44d805344e46"
        }
    }
}
```
